package com.persagy.fm.sop.model.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-16
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class Sop extends Model<Sop> {

    private static final long serialVersionUID=1L;

    /**
     * sopid SOP+uuid
     */
    @TableId(value = "sop_id", type = IdType.ASSIGN_UUID)
    private String sopId;

    /**
     * sop所属的项目 集团sop的项目Id默认为"group_sop_id"
     */
    private String projectId;

    /**
     * 项目类型：同一级建筑功能类型 ，字段使用原有的extend_field保存
     */
    private String extendField;

    /**
     * 表示sop的发布者、更新者
     */
    private String operator;

    /**
     * 名称,项目下唯一
     */
    private String sopName;

    /**
     * 1-集团，2-项目专用
     */
    private String sopType;

    /**
     * 0-否 1-是
     */
    private String noObj;

    /**
     * 数组[code，code]，
子项：SE-强电，WE-弱电，AC-空调，WS-给排水，FF-消防，SP-安防
     */
    private String domains;

    /**
     * 数组[code，code]
     */
    private String orderType;

    /**
     * 数组[{"tool"：“……”,"from_step":true}]
     */
    private String tools;

    /**
     * [{
      "obj_id:"***", //对象id
      "obj_name:"对象名称1", //对象名称
      "obj_type":"equip",  //对象类型,子项见后边
}]
obj_tye:build-建筑、floor-楼层、space-空间、system-系统实例、equip-设备实例，system_class-系统类、equip_class-设备类
     */
    private String fitObjs;

    /**
     * [equip_model_id,equip_model_id]
     */
    private String equipModelIds;

    /**
     * [name,name]
     */
    private String labels;

    /**
     * 步骤的版本
     */
    private String stepsVersion;

    /**
     * 步骤
     */
    private String steps;

    /**
     * [{"name":"***'，“url”：“***”}，{}]
     */
    private String relatedData;

    /**
     * 1-已发布、2-已作废
     */
    private String sopStatus;

    /**
     * 1-正常、2-待修订、3-修订中
     */
    private String publishStatus;

    /**
     * id的数组[sop_id,sop_id]
     */
    private String refSopIds;

    private String versionCount;

    private String versionExplain;

    /**
     * 数组[“描述”,“描述”]
     */
    private String versionExp;

    /**
     * 是否有效
     */
    private Boolean valid;

    private String updateTime;


    @Override
    protected Serializable pkVal() {
        return this.sopId;
    }

}
